<?php
/*
Plugin Name: Google Buzz ER
Plugin URI: http://workshop.rs/2010/02/google-buzz-er-google-buzz-for-wordpress/
Description: Displaying posts from Google Buzz.
Version: 1.4
Author: Ivan Lazarevic
Author URI: http://www.workshop.rs
*/

/*  Copyright 2010  Ivan Lazarevic  (email : devet.sest@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* options page */
$options_page = get_option('siteurl') . '/wp-admin/admin.php?page=google-buzz-er/options.php';

/* Adds our admin options under "Options" */
function gber_options_page() {
	add_options_page('Google Buzz ER', 'Google Buzz ER', 10, 'google-buzz-er/options.php');
}

function gber_head(){
	 
	$path =  get_bloginfo('wpurl')."/wp-content/plugins/google-buzz-er/";

	$script = "
		<link rel=\"stylesheet\" href=\"".$path."css/google-buzz-er.css.php\" type=\"text/css\" media=\"screen\" charset=\"utf-8\"/>
	";

	echo $script;
}



function GoogleBuzzEr(){
	new GoogleBuzzEr_Start;
}

class GoogleBuzzEr_Start {

	private $T_URL 	  = "http://buzz.googleapis.com/feeds/";

	function __construct(){
		
		$this->gb_getData();
		
	}
	
	
	function gb_getData(){
		
		$user = get_option('gber_username');
		
		$xml = @simplexml_load_file($this->T_URL.$user."/public/posted");
		
		// solution by huangda1982 [ http://huangda1982.xtreemhost.com/ ]
		if(!$xml) {
			$url = $this->T_URL.$user."/public/posted";
			$curl = curl_init( $url );
			ob_start(); // use output buffering so the contents dont get sent directly to the browser
			curl_exec( $curl ); // get the file
			curl_close( $curl );
			$data = @ob_get_contents(); // save the contents of the file into $file
			ob_end_clean(); // turn output buffering back off
			$xml = @simplexml_load_string($data);			
		}
		
		if(!$xml){
			echo "Error loading Google Buzz data!";
			return false;
		}
			
		$imgWidth 	= is_numeric(get_option('gber_post_image_width')) ? get_option('gber_post_image_width') : 150;	
		$imgShow	= get_option('gber_post_image') ? get_option('gber_post_image') : false;
		
		foreach($xml->entry as $data){
				$namespaces = $data->getNameSpaces(true);


			if($data->content){
				$tmp['content'] 	= (string)$data->content;
				$tmp['name'] 		= $data->author->name;
				$tmp['uri'] 		= $data->author->uri;				
				$tmp['updated']		= $data->updated;
				$tmp['href'] 		= $data->link['href'];
				$tmp['timestamp']	= strtotime($data->updated);
				
				
				$imgSrcCont		= '';
				if($imgShow){
					$media 		= $data->children($namespaces['media']);
					$mediaAttr 	= $media->content->attributes();
					
					if($mediaAttr[2] == image) {
						$imgSrc 	= $media->content->player->attributes();
						$imgSrcCont = "<span class='gber_image'><img src='{$imgSrc[0]}' width='$imgWidth' /></span>";	
					}
				}
				
				$tmp['imgSrcCont'] 	= $imgSrcCont;
					
				$sts[] = $tmp;				
			}
		}

		/* sort statuses array by timestamp */
		if(count($sts) > 0){
			$tmp = $sts;
			foreach ($tmp as $key=>$row) {
				$text[$key] = $row['timestamp'];
			}
		
			array_multisort($text,SORT_DESC,$tmp);
		
			$sts = $tmp;
		}
		/* end sorting */	
		
		$this->gb_printData($sts);
		
	}
	
	function gb_printData($data){
	
		$no_of_posts = is_numeric(get_option('gber_number')) ? get_option('gber_number') : 15;
		$title		 = get_option('gber_title') ? get_option('gber_title') : $data[0]['name'];
		
		$out = "
		<div id='gber_wrapper'>
			<div id='gber_title'>
				<a href='{$data[0]['uri']}'>$title</a>
			</div>";
		
		$i = 0;
		foreach($data as $k=>$v){
			$out .= "
			<div class='gber_post'>
				{$v['content']}
				{$v['imgSrcCont']}
				<span class='gber_time'>{$this->gb_showTime(strtotime($v['updated']))}, </span>
				<span class='gber_comment'><a href='{$v['href']}'>comment</a></span>
			</div>";
			$i++;
			if($i == $no_of_posts) break;
				
		}
		
		$out .= "
			<a href='http://www.google.com/buzz' id='gber_small'>&nbsp;</a>
		</div>";
		
		echo $out;
	
	}
	

	
	/**
	 * Create 'human readable' date format from timestamp
	 * 
	 * @param $ts - timestamp
	 * 
	 * TODO fix for 1st, 2nd, 3rd 
	 * 
	 */
	private function gb_showTime($ts){
		$c = time() - $ts;
		$nd = date('g:i A M d\, Y',$ts);
		
		if ($c < 60) return $c.' seconds ago';
		elseif ($c < 3600) return (int)($c/60).' minutes ago';
		elseif ($c < 3600*24) return (int)($c/3600).' hours ago';
		else return $nd;
	}

}

class GoogleBuzzEr{
  function control(){
    echo 'Configure this widget on <a href="'.get_option('siteurl') . '/wp-admin/admin.php?page=google-buzz-er/options.php'.'">options page</a>';
  }
  function widget($args){
    echo $args['before_widget'];
    new GoogleBuzzEr_Start();
    echo $args['after_widget'];
  }
  function register(){
    register_sidebar_widget('Google Buzz Er', array('GoogleBuzzEr', 'widget'));
    register_widget_control('Google Buzz Er', array('GoogleBuzzEr', 'control'));
  }
}



add_action('wp_head','gber_head');
add_action('admin_menu','gber_options_page');
add_action("widgets_init", array('GoogleBuzzEr', 'register'));
?>